;USB Browse
.nolist 
#include "dcs6.inc"
USBDriverCall = 280 + $86ec
USBDriverBuf  = USBDriverCall + 32
DBuf		  = USBDriverBuf+128
savesscreen	= $86ec	;aka SERam
#include "usb8xspasm.inc"
_strcpy		=$44E3 
_MultAbyE	=$8042	
_memclear 	=$4c30	
_findapp	=$4c4e
;SEOffset	equ	$86ec
.list
	.org 0
	.db $BB,$6D		;ASM program header
	.db $AB,$C9		;ignore program; ret
SEStart:
	.db $31,$87,$50		;SE for DCS 5 and higher
	.dw SEBoot-SEStart	;or .dw 0 if there is no boot section in this SE
	.dw SEMouse-SEStart	;or .dw 0 if there is no mouse section in this SE
	.dw SEUnload-SEStart	;or .dw 0 if there is no unload section in this SE
SEBoot:			;if there is a boot section...
	;...code...
	in a,(6)
	ld (ix),a
	ret
SEOffset = SERam - $
SEMouse:	

	;ld d,0
	;ret
	;if there is a mouse section...
	;...code...
	in a,(2)
	ld b,a
	and 80h
	jp z,TI83p+SEOffset
	in a,(21h)
	and 3
	jp z,TI84p+SEOffset
	bit 5,b
	jp z,TI83p+SEOffset
TI84p:
.echo "SEoffset"
.echo (TI84p + SEOffset)
	push ix
	ld	hl,uuAppName+SEOffset
	rst    20h  ;move 9 to op1
	;bcall(_mov9toop1)
	bcall(_findapp)
	jp     c,uuDone1+SEOffset
	
	ld     (USBDriverCall+uuMod1 + 1),a
	in     a,(6)
	ld     (USBDriverCall+uuMod3 +1),a
	or     a

	;in a,(6)
uuDone1:
	jp	c,NOUSB+SEOffset
	ld	hl,USBDriverBuf	
	U_CALL(DriverInit)
	jp	c,USBERR+SEOffset
	ld	hl,DBuf
	ld	bc,256
	bcall(_MemClear)
	ld	de,DBuf
	ld	b,0
	U_CALL(MouseInit)
	jp	c,USBERR+SEOffset
	;;;;;;;;;;;;
	U_CALL(MouseGetKey)
	bit 0,b
	jr nz,LeftClick
	bit 1,b
	jr nz,RightClick
	bit mouseBitRight,c
	jr nz,MoveRight
	bit mouseBitLeft,c
	jr nz,MoveLeft
	bit mouseBitUp,c
	jr nz,MoveUp
	bit mouseBitDown,c
	jr nz,MoveDown

LeftClick:
	pop ix
	ld a,(ix)
	out (6),a
	ld d,1
	ret
RightClick:
	pop ix
	ld a,(ix)
	out (6),a
	ld d,2
	ret
MoveLeft:
	pop ix
	ld a,(ix)
	out (6),a
	ld d,5
	ret
MoveRight:
	pop ix
	ld a,(ix)
	out (6),a
	ld d,6
	ret
MoveUp:
	pop ix
	ld a,(ix)
	out (6),a
	ld d,3
	ret
MoveDown:
	pop ix
	ld a,(ix)
	out (6),a
	ld d,4
	ret
NOUSB:
USBERR:
	pop ix
	ld a,(ix)
	out (6),a
TI83P:
	ld d,0
Stub:
	ret
uuAppName:
	.db     $14,"USBDRV8X",0
MyRam = $ - SEMouse
	.echo "Mouse Module Size:"
	.echo $ - SEMouse
uuDriverCode:
	push   af
	in     a,(6)
	ld     (USBDriverCall+uuMod2 +1),a
	call	USBDriverCall+uuCall1
	pop    af
	call   USBDriverEntryPoint
	push   af
uuMod2 = $ - uuDriverCode
	ld     a,0
	out    (6),a
	pop    af
	ret
uuCallBack:
uuMod3 = $-uuDriverCode
	ld     a,0
	out    (6),a
	call   Stub+SEOffset
uuCall1 EQU $-uuDriverCode
uuMod1 EQU $-uuDriverCode
	ld	a,0
	out    (6),a
	ret
uuDriverSize = $ - uuDriverCode
uuDone:
offCallBack = uuCallBack-uuDriverCode

SEUnload:
	U_CALL(HostKill)
	U_CALL(DriverKill)
	ret
	
.end
END